#include "particle.h"

Particle particles[MAX_PARTICLES];
int currentParticle = 0;

Particle* getParticleArray() {
  return particles;
}

void initParticles () {
  for (int i = 0; i < MAX_PARTICLES; i++) {
    initParticle(particles[i]);
  }
}

void initParticle (Particle &p) {
  int hiddenLocation = 657;
  p.pos = glm::vec3(hiddenLocation, hiddenLocation, hiddenLocation);
  p.vel = glm::vec3(hiddenLocation, hiddenLocation, hiddenLocation);
}

void addParticle (glm::vec3 p, glm::vec3 v) {
  particles[currentParticle].vel.x = v.x;
  particles[currentParticle].vel.y = v.y;
  particles[currentParticle].vel.z = v.z;
  particles[currentParticle].pos.x = p.x;
  particles[currentParticle].pos.y = p.y;
  particles[currentParticle].pos.z = p.z;
  particles[currentParticle].color.x = 1;
  particles[currentParticle].color.y = 1;
  particles[currentParticle].color.z = 1;
  particles[currentParticle].color.w = .3;
  currentParticle++;
  currentParticle %= MAX_PARTICLES;
}

void updateParticles (float time, glm::vec3 wind) {
  for (int i = 0; i < MAX_PARTICLES; i++) {
    particles[i].pos.x += (particles[i].vel.x + wind.x) * time;
    particles[i].pos.y += (particles[i].vel.y + wind.y) * time;
    particles[i].pos.z += (particles[i].vel.z + wind.z) * time;
    if (particles[i].color.z > 0) {
      particles[i].color.z -= (rand() % 1337) / 13370.0f * 2.8f;
    } else if (particles[i].color.y > 0) {
      particles[i].color.y -= (rand() % 1337) / 13370.0f * 2.0f;
    } else if (particles[i].color.x > 0) {
      particles[i].color.x -= (rand() % 1337) / 13370.0f * 3.0f;
      particles[i].color.w -= .001337;
    }
  }
}
