#ifndef _PARTICLE_H_
#define _PARTICLE_H_

#ifdef __APPLE__
#include <OpenGL/gl.h>
#endif
#ifdef __unix__
#include <GL/gl.h>
#endif
#include "glm/glm.hpp"
#include "RenderingHelper.h"

#define MAX_PARTICLES 2000

typedef struct {
  glm::vec3 pos;
  glm::vec3 vel;
  glm::vec4 color;
} Particle;

void initParticle (Particle &p);
void initParticles ();
void addParticle (glm::vec3 p, glm::vec3 v);
Particle* getParticleArray ();
void updateParticles (float time, glm::vec3 wind);

#endif

